libssh: The libssh SFTP API

libssh 0.7.3

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Data Structures | Functions
The libssh SFTP API

SFTP handling functions. More...

## Data Structures
struct | sftp_statvfs_t
| SFTP statvfs structure. More...

## Functions
int | sftp_async_read (sftp_file file, void *data, uint32_t len, uint32_t id)
| Wait for an asynchronous read to complete and save the data. More...
int | sftp_async_read_begin (sftp_file file, uint32_t len)
| Start an asynchronous read from a file using an opened sftp file handle. More...
void | sftp_attributes_free (sftp_attributes file)
| Free a sftp attribute structure. More...
char * | sftp_canonicalize_path (sftp_session sftp, const char *path)
| Canonicalize a sftp path. More...
int | sftp_chmod (sftp_session sftp, const char *file, mode_t mode)
| Change permissions of a file. More...
int | sftp_chown (sftp_session sftp, const char *file, uid_t owner, gid_t group)
| Change the file owner and group. More...
int | sftp_close (sftp_file file)
| Close an open file handle. More...
int | sftp_closedir (sftp_dir dir)
| Close a directory handle opened by sftp_opendir(). More...
int | sftp_dir_eof (sftp_dir dir)
| Tell if the directory has reached EOF (End Of File). More...
int | sftp_extension_supported (sftp_session sftp, const char *name, const char *data)
| Check if the given extension is supported. More...
unsigned int | sftp_extensions_get_count (sftp_session sftp)
| Get the count of extensions provided by the server. More...
const char * | sftp_extensions_get_data (sftp_session sftp, unsigned int indexn)
| Get the data of the extension provided by the server. More...
const char * | sftp_extensions_get_name (sftp_session sftp, unsigned int indexn)
| Get the name of the extension provided by the server. More...
void | sftp_file_set_blocking (sftp_file handle)
| Make the sftp communication for this file handle blocking. More...
void | sftp_file_set_nonblocking (sftp_file handle)
| Make the sftp communication for this file handle non blocking. More...
void | sftp_free (sftp_session sftp)
| Close and deallocate a sftp session. More...
sftp_attributes | sftp_fstat (sftp_file file)
| Get information about a file or directory from a file handle. More...
sftp_statvfs_t | sftp_fstatvfs (sftp_file file)
| Get information about a mounted file system. More...
int | sftp_get_error (sftp_session sftp)
| Get the last sftp error. More...
int | sftp_init (sftp_session sftp)
| Initialize the sftp session with the server. More...
sftp_attributes | sftp_lstat (sftp_session session, const char *path)
| Get information about a file or directory. More...
int | sftp_mkdir (sftp_session sftp, const char *directory, mode_t mode)
| Create a directory. More...
sftp_session | sftp_new (ssh_session session)
| Start a new sftp session. More...
sftp_session | sftp_new_channel (ssh_session session, ssh_channel channel)
| Start a new sftp session with an existing channel. More...
sftp_file | sftp_open (sftp_session session, const char *file, int accesstype, mode_t mode)
| Open a file on the server. More...
sftp_dir | sftp_opendir (sftp_session session, const char *path)
| Open a directory used to obtain directory entries. More...
ssize_t | sftp_read (sftp_file file, void *buf, size_t count)
| Read from a file using an opened sftp file handle. More...
sftp_attributes | sftp_readdir (sftp_session session, sftp_dir dir)
| Get a single file attributes structure of a directory. More...
char * | sftp_readlink (sftp_session sftp, const char *path)
| Read the value of a symbolic link. More...
int | sftp_rename (sftp_session sftp, const char *original, const char *newname)
| Rename or move a file or directory. More...
void | sftp_rewind (sftp_file file)
| Rewinds the position of the file pointer to the beginning of the file. More...
int | sftp_rmdir (sftp_session sftp, const char *directory)
| Remove a directoy. More...
int | sftp_seek (sftp_file file, uint32_t new_offset)
| Seek to a specific location in a file. More...
int | sftp_seek64 (sftp_file file, uint64_t new_offset)
| Seek to a specific location in a file. More...
int | sftp_server_init (sftp_session sftp)
| Intialize the sftp server. More...
sftp_session | sftp_server_new (ssh_session session, ssh_channel chan)
| Create a new sftp server session. More...
int | sftp_server_version (sftp_session sftp)
| Get the version of the SFTP protocol supported by the server. More...
int | sftp_setstat (sftp_session sftp, const char *file, sftp_attributes attr)
| Set file attributes on a file, directory or symbolic link. More...
sftp_attributes | sftp_stat (sftp_session session, const char *path)
| Get information about a file or directory. More...
sftp_statvfs_t | sftp_statvfs (sftp_session sftp, const char *path)
| Get information about a mounted file system. More...
void | sftp_statvfs_free (sftp_statvfs_t statvfs_o)
| Free the memory of an allocated statvfs. More...
int | sftp_symlink (sftp_session sftp, const char *target, const char *dest)
| Create a symbolic link. More...
unsigned long | sftp_tell (sftp_file file)
| Report current byte position in file. More...
uint64_t | sftp_tell64 (sftp_file file)
| Report current byte position in file. More...
int | sftp_unlink (sftp_session sftp, const char *file)
| Unlink (delete) a file. More...
int | sftp_utimes (sftp_session sftp, const char *file, const struct timeval *times)
| Change the last modification and access time of a file. More...
ssize_t | sftp_write (sftp_file file, const void *buf, size_t count)
| Write to a file using an opened sftp file handle. More...

## Server responses
Responses returned by the sftp server.
#define | SSH_FX_OK 0
| No error.
#define | SSH_FX_EOF 1
| End-of-file encountered.
#define | SSH_FX_NO_SUCH_FILE 2
| File doesn't exist.
#define | SSH_FX_PERMISSION_DENIED 3
| Permission denied.
#define | SSH_FX_FAILURE 4
| Generic failure.
#define | SSH_FX_BAD_MESSAGE 5
| Garbage received from server.
#define | SSH_FX_NO_CONNECTION 6
| No connection has been set up.
#define | SSH_FX_CONNECTION_LOST 7
| There was a connection, but we lost it.
#define | SSH_FX_OP_UNSUPPORTED 8
| Operation not supported by the server.
#define | SSH_FX_INVALID_HANDLE 9
| Invalid file handle.
#define | SSH_FX_NO_SUCH_PATH 10
| No such file or directory path exists.
#define | SSH_FX_FILE_ALREADY_EXISTS 11
| An attempt to create an already existing file or directory has been made.
#define | SSH_FX_WRITE_PROTECT 12
| We are trying to write on a write-protected filesystem.
#define | SSH_FX_NO_MEDIA 13
| No media in remote drive.

## Detailed Description

SFTP handling functions.

SFTP commands are channeled by the ssh sftp subsystem. Every packet is sent/read using a sftp_packet type structure. Related to these packets, most of the server answers are messages having an ID and a message specific part. It is described by sftp_message when reading a message, the sftp system puts it into the queue, so the process having asked for it can fetch it, while continuing to read for other messages (it is unspecified in which order messages may be sent back to the client

## Function Documentation

int sftp_async_read | ( | sftp_file | file,
|  | void * | data,
|  | uint32_t | len,
|  | uint32_t | id
| ) |  |

Wait for an asynchronous read to complete and save the data.

Parameters

  file | The opened sftp file handle to be read from.
  data | Pointer to buffer to recieve read data.
  len | Size of the buffer in bytes. It should be bigger or equal to the length parameter of the sftp_async_read_begin() call.
  id | The identifier returned by the sftp_async_read_begin() function.

Returns
  Number of bytes read, 0 on EOF, SSH_ERROR if an error occured, SSH_AGAIN if the file is opened in nonblocking mode and the request hasn't been executed yet.

Warning
  A call to this function with an invalid identifier will never return.

See also
  sftp_async_read_begin()

References ssh_channel_poll(), SSH_FX_EOF, ssh_string_data(), ssh_string_free(), and ssh_string_len().

int sftp_async_read_begin | ( | sftp_file | file,
|  | uint32_t | len
| ) |  |

Start an asynchronous read from a file using an opened sftp file handle.

Its goal is to avoid the slowdowns related to the request/response pattern of a synchronous read. To do so, you must call 2 functions:

sftp_async_read_begin() and sftp_async_read().

The first step is to call sftp_async_read_begin(). This function returns a request identifier. The second step is to call sftp_async_read() using the returned identifier.

Parameters

  file | The opened sftp file handle to be read from.
  len | Size to read in bytes.

Returns
  An identifier corresponding to the sent request, < 0 on error.

Warning
  When calling this function, the internal offset is updated corresponding to the len parameter.
  A call to sftp_async_read_begin() sends a request to the server. When the server answers, libssh allocates memory to store it until sftp_async_read() is called. Not calling sftp_async_read() will lead to memory leaks.

See also
  sftp_async_read()
  sftp_open()

References ssh_buffer_free(), and ssh_buffer_new().

void sftp_attributes_free | ( | sftp_attributes | file | ) |

Free a sftp attribute structure.

Parameters

  file | The sftp attribute structure to free.

References ssh_buffer_free(), ssh_buffer_new(), SSH_FX_OK, and ssh_string_free().

char* sftp_canonicalize_path | ( | sftp_session | sftp,
|  | const char * | path
| ) |  |

Canonicalize a sftp path.

Parameters

  sftp | The sftp session handle.
  path | The path to be canonicalized.

Returns
  The canonicalize path, NULL on error.

References ssh_buffer_free(), ssh_buffer_new(), ssh_string_free(), ssh_string_from_char(), and ssh_string_to_char().

int sftp_chmod | ( | sftp_session | sftp,
|  | const char * | file,
|  | mode_t | mode
| ) |  |

Change permissions of a file.

Parameters

  sftp | The sftp session handle.
  file | The file which owner and group should be changed.
  mode | Specifies the permissions to use. It is modified by the process's umask in the usual way: The permissions of the created file are (mode & ~umask)

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References sftp_setstat().

int sftp_chown | ( | sftp_session | sftp,
|  | const char * | file,
|  | uid_t | owner,
|  | gid_t | group
| ) |  |

Change the file owner and group.

Parameters

  sftp | The sftp session handle.
  file | The file which owner and group should be changed.
  owner | The new owner which should be set.
  group | The new group which should be set.

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References sftp_setstat().

int sftp_close | ( | sftp_file | file | ) |

Close an open file handle.

Parameters

  file | The open sftp file handle to close.

Returns
  Returns SSH_NO_ERROR or SSH_ERROR if an error occured.

See also
  sftp_open()

References ssh_string_free().

int sftp_closedir | ( | sftp_dir | dir | ) |

Close a directory handle opened by sftp_opendir().

Parameters

  dir | The sftp directory handle to close.

Returns
  Returns SSH_NO_ERROR or SSH_ERROR if an error occured.

References ssh_buffer_free(), and ssh_string_free().

int sftp_dir_eof | ( | sftp_dir | dir | ) |

Tell if the directory has reached EOF (End Of File).

Parameters

  dir | The sftp directory handle.

Returns
  1 if the directory is EOF, 0 if not.

See also
  sftp_readdir()

int sftp_extension_supported | ( | sftp_session | sftp,
|  | const char * | name,
|  | const char * | data
| ) |  |

Check if the given extension is supported.

Parameters

  sftp | The sftp session to use.
  name | The name of the extension.
  data | The data of the extension.

Returns
  1 if supported, 0 if not.

Example:

1 sftp_extension_supported(sftp, "statvfs@openssh.com", "2");

References sftp_extensions_get_count(), sftp_extensions_get_data(), sftp_extensions_get_name(), and SSH_LOG_PACKET.

unsigned int sftp_extensions_get_count | ( | sftp_session | sftp | ) |

Get the count of extensions provided by the server.

Parameters

  sftp | The sftp session to use.

Returns
  The count of extensions provided by the server, 0 on error or not available.

Referenced by sftp_extension_supported().

const char* sftp_extensions_get_data | ( | sftp_session | sftp,
|  | unsigned int | indexn
| ) |  |

Get the data of the extension provided by the server.

This is normally the version number of the extension.

Parameters

  sftp | The sftp session to use.
  indexn | The index number of the extension data you want.

Returns
  The data of the extension.

Referenced by sftp_extension_supported().

const char* sftp_extensions_get_name | ( | sftp_session | sftp,
|  | unsigned int | indexn
| ) |  |

Get the name of the extension provided by the server.

Parameters

  sftp | The sftp session to use.
  indexn | The index number of the extension name you want.

Returns
  The name of the extension.

Referenced by sftp_extension_supported().

void sftp_file_set_blocking | ( | sftp_file | handle | ) |

Make the sftp communication for this file handle blocking.

Parameters

  [in] | handle | The file handle to set blocking.

void sftp_file_set_nonblocking | ( | sftp_file | handle | ) |

Make the sftp communication for this file handle non blocking.

Parameters

  [in] | handle | The file handle to set non blocking.

void sftp_free | ( | sftp_session | sftp | ) |

Close and deallocate a sftp session.

Parameters

  sftp | The sftp session handle to free.

References ssh_buffer_free(), ssh_buffer_new(), ssh_channel_free(), ssh_channel_read(), ssh_channel_send_eof(), ssh_channel_write(), and SSH_LOG_PACKET.

Referenced by sftp_new().

sftp_attributes sftp_fstat | ( | sftp_file | file | ) |

Get information about a file or directory from a file handle.

Parameters

  file | The sftp file handle to get the stat information.

Returns
  The sftp attributes structure of the file or directory, NULL on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), and ssh_buffer_new().

sftp_statvfs_t sftp_fstatvfs | ( | sftp_file | file | ) |

Get information about a mounted file system.

Parameters

  file | An opened file.

Returns
  A statvfs structure or NULL on error.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), ssh_string_free(), and ssh_string_from_char().

int sftp_get_error | ( | sftp_session | sftp | ) |

Get the last sftp error.

Use this function to get the latest error set by a posix like sftp function.

Parameters

  sftp | The sftp session where the error is saved.

Returns
  The saved error (see server responses), < 0 if an error in the function occured.

See also
  Server responses

References ssh_buffer_free(), ssh_buffer_new(), and SSH_LOG_PACKET.

int sftp_init | ( | sftp_session | sftp | ) |

Initialize the sftp session with the server.

Parameters

  sftp | The sftp session to initialize.

Returns
  0 on success, < 0 on error with ssh error set.

See also
  sftp_new()

References ssh_buffer_free(), and ssh_buffer_new().

sftp_attributes sftp_lstat | ( | sftp_session | session,
|  | const char * | path
| ) |  |

Get information about a file or directory.

Identical to sftp_stat, but if the file or directory is a symbolic link, then the link itself is stated, not the file that it refers to.

Parameters

  session | The sftp session handle.
  path | The path to the file or directory to obtain the information.

Returns
  The sftp attributes structure of the file or directory, NULL on error with ssh and sftp error set.

See also
  sftp_get_error()

Referenced by sftp_mkdir().

int sftp_mkdir | ( | sftp_session | sftp,
|  | const char * | directory,
|  | mode_t | mode
| ) |  |

Create a directory.

Parameters

  sftp | The sftp session handle.
  directory | The directory to create.
  mode | Specifies the permissions to use. It is modified by the process's umask in the usual way: The permissions of the created file are (mode & ~umask)

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References sftp_lstat(), ssh_buffer_free(), ssh_buffer_new(), SSH_FX_FAILURE, SSH_FX_FILE_ALREADY_EXISTS, SSH_FX_OK, ssh_string_free(), and ssh_string_from_char().

sftp_session sftp_new | ( | ssh_session | session | ) |

Start a new sftp session.

Parameters

  session | The ssh session to use.

Returns
  A new sftp session or NULL on error.

See also
  sftp_free()

References sftp_free(), ssh_channel_free(), ssh_channel_new(), and ssh_channel_open_session().

sftp_session sftp_new_channel | ( | ssh_session | session,
|  | ssh_channel | channel
| ) |  |

Start a new sftp session with an existing channel.

Parameters

  session | The ssh session to use.
  channel | An open session channel with subsystem already allocated

Returns
  A new sftp session or NULL on error.

See also
  sftp_free()

sftp_file sftp_open | ( | sftp_session | session,
|  | const char * | file,
|  | int | accesstype,
|  | mode_t | mode
| ) |  |

Open a file on the server.

Parameters

  session | The sftp session handle.
  file | The file to be opened.
  accesstype | Is one of O_RDONLY, O_WRONLY or O_RDWR which request opening the file read-only,write-only or read/write. Acesss may also be bitwise-or'd with one or more of the following: O_CREAT - If the file does not exist it will be created. O_EXCL - When used with O_CREAT, if the file already exists it is an error and the open will fail. O_TRUNC - If the file already exists it will be truncated.
  mode | Mode specifies the permissions to use if a new file is created. It is modified by the process's umask in the usual way: The permissions of the created file are (mode & ~umask)

Returns
  A sftp file handle, NULL on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), SSH_LOG_PACKET, ssh_string_free(), and ssh_string_from_char().

sftp_dir sftp_opendir | ( | sftp_session | session,
|  | const char * | path
| ) |  |

Open a directory used to obtain directory entries.

Parameters

  session | The sftp session handle to open the directory.
  path | The path of the directory to open.

Returns
  A sftp directory handle or NULL on error with ssh and sftp error set.

See also
  sftp_readdir
  sftp_closedir

References ssh_buffer_free(), ssh_buffer_new(), ssh_get_openssh_version(), ssh_string_free(), ssh_string_from_char(), and ssh_string_to_char().

ssize_t sftp_read | ( | sftp_file | file,
|  | void * | buf,
|  | size_t | count
| ) |  |

Read from a file using an opened sftp file handle.

Parameters

  file | The opened sftp file handle to be read from.
  buf | Pointer to buffer to recieve read data.
  count | Size of the buffer in bytes.

Returns
  Number of bytes written, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), ssh_channel_poll(), SSH_FX_EOF, ssh_string_data(), ssh_string_free(), and ssh_string_len().

sftp_attributes sftp_readdir | ( | sftp_session | session,
|  | sftp_dir | dir
| ) |  |

Get a single file attributes structure of a directory.

Parameters

  session | The sftp session handle to read the directory entry.
  dir | The opened sftp directory handle to read from.

Returns
  A file attribute structure or NULL at the end of the directory.

See also
  sftp_opendir()
  sftp_attribute_free()
  sftp_closedir()

References ssh_buffer_free(), ssh_buffer_new(), SSH_FX_EOF, and SSH_LOG_PACKET.

char* sftp_readlink | ( | sftp_session | sftp,
|  | const char * | path
| ) |  |

Read the value of a symbolic link.

Parameters

  sftp | The sftp session handle.
  path | Specifies the path name of the symlink to be read.

Returns
  The target of the link, NULL on error.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), ssh_string_free(), ssh_string_from_char(), and ssh_string_to_char().

int sftp_rename | ( | sftp_session | sftp,
|  | const char * | original,
|  | const char * | newname
| ) |  |

Rename or move a file or directory.

Parameters

  sftp | The sftp session handle.
  original | The original url (source url) of file or directory to be moved.
  newname | The new url (destination url) of the file or directory after the move.

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), and SSH_FX_OK.

void sftp_rewind | ( | sftp_file | file | ) |

Rewinds the position of the file pointer to the beginning of the file.

Parameters

  file | Open sftp file handle.

int sftp_rmdir | ( | sftp_session | sftp,
|  | const char * | directory
| ) |  |

Remove a directoy.

Parameters

  sftp | The sftp session handle.
  directory | The directory to remove.

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), and SSH_FX_OK.

int sftp_seek | ( | sftp_file | file,
|  | uint32_t | new_offset
| ) |  |

Seek to a specific location in a file.

Parameters

  file | Open sftp file handle to seek in.
  new_offset | Offset in bytes to seek.

Returns
  0 on success, < 0 on error.

int sftp_seek64 | ( | sftp_file | file,
|  | uint64_t | new_offset
| ) |  |

Seek to a specific location in a file.

This is the 64bit version.

Parameters

  file | Open sftp file handle to seek in.
  new_offset | Offset in bytes to seek.

Returns
  0 on success, < 0 on error.

int sftp_server_init | ( | sftp_session | sftp | ) |

Intialize the sftp server.

Parameters

  sftp | The sftp session to init.

Returns
  0 on success, < 0 on error.

References ssh_buffer_free(), ssh_buffer_new(), and SSH_LOG_PACKET.

sftp_session sftp_server_new | ( | ssh_session | session,
|  | ssh_channel | chan
| ) |  |

Create a new sftp server session.

Parameters

  session | The ssh session to use.
  chan | The ssh channel to use.

Returns
  A new sftp server session.

int sftp_server_version | ( | sftp_session | sftp | ) |

Get the version of the SFTP protocol supported by the server.

Parameters

  sftp | The sftp session handle.

Returns
  The server version.

int sftp_setstat | ( | sftp_session | sftp,
|  | const char * | file,
|  | sftp_attributes | attr
| ) |  |

Set file attributes on a file, directory or symbolic link.

Parameters

  sftp | The sftp session handle.
  file | The file which attributes should be changed.
  attr | The file attributes structure with the attributes set which should be changed.

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), SSH_FX_OK, ssh_string_free(), and ssh_string_from_char().

Referenced by sftp_chmod(), sftp_chown(), and sftp_utimes().

sftp_attributes sftp_stat | ( | sftp_session | session,
|  | const char * | path
| ) |  |

Get information about a file or directory.

Parameters

  session | The sftp session handle.
  path | The path to the file or directory to obtain the information.

Returns
  The sftp attributes structure of the file or directory, NULL on error with ssh and sftp error set.

See also
  sftp_get_error()

sftp_statvfs_t sftp_statvfs | ( | sftp_session | sftp,
|  | const char * | path
| ) |  |

Get information about a mounted file system.

Parameters

  sftp | The sftp session handle.
  path | The pathname of any file within the mounted file system.

Returns
  A statvfs structure or NULL on error.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), ssh_string_free(), and ssh_string_from_char().

void sftp_statvfs_free | ( | sftp_statvfs_t | statvfs_o | ) |

Free the memory of an allocated statvfs.

Parameters

  statvfs_o | The statvfs to free.

int sftp_symlink | ( | sftp_session | sftp,
|  | const char * | target,
|  | const char * | dest
| ) |  |

Create a symbolic link.

Parameters

  sftp | The sftp session handle.
  target | Specifies the target of the symlink.
  dest | Specifies the path name of the symlink to be created.

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), SSH_FX_OK, and ssh_get_openssh_version().

unsigned long sftp_tell | ( | sftp_file | file | ) |

Report current byte position in file.

Parameters

  file | Open sftp file handle.

Returns
  The offset of the current byte relative to the beginning of the file associated with the file descriptor. < 0 on error.

uint64_t sftp_tell64 | ( | sftp_file | file | ) |

Report current byte position in file.

Parameters

  file | Open sftp file handle.

Returns
  The offset of the current byte relative to the beginning of the file associated with the file descriptor. < 0 on error.

int sftp_unlink | ( | sftp_session | sftp,
|  | const char * | file
| ) |  |

Unlink (delete) a file.

Parameters

  sftp | The sftp session handle.
  file | The file to unlink/delete.

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References ssh_buffer_free(), ssh_buffer_new(), and SSH_FX_OK.

int sftp_utimes | ( | sftp_session | sftp,
|  | const char * | file,
|  | const struct timeval * | times
| ) |  |

Change the last modification and access time of a file.

Parameters

  sftp | The sftp session handle.
  file | The file which owner and group should be changed.
  times | A timeval structure which contains the desired access and modification time.

Returns
  0 on success, < 0 on error with ssh and sftp error set.

See also
  sftp_get_error()

References sftp_setstat().

ssize_t sftp_write | ( | sftp_file | file,
|  | const void * | buf,
|  | size_t | count
| ) |  |

Write to a file using an opened sftp file handle.

Parameters

  file | Open sftp file handle to write to.
  buf | Pointer to buffer to write data.
  count | Size of buffer in bytes.

Returns
  Number of bytes written, < 0 on error with ssh and sftp error set.

See also
  sftp_open()
  sftp_read()
  sftp_close()

References ssh_buffer_free(), ssh_buffer_new(), SSH_FX_OK, and SSH_LOG_PACKET.